View Issue Details

IDProjectCategoryView StatusLast Update
08806Bug reportsSurvey takingpublic2016-01-25 08:21
ReporterDenisChenu Assigned ToDenisChenu  
PrioritynormalSeverityminor 
Status closedResolutionfixed 
Product Version2.05+ 
Fixed in Version2.05+ 
Summary08806: questionindex to 2 allow invalid survey submitted
Description

If use survey index to Complete and set some mandatory question : user can submit the survey without answering to this question.

Steps To Reproduce

Import the lsa file, lauch, click on G4 3 times, click on submit.

TagsNo tags attached.
Complete LimeSurvey version number (& build)140304
I will donate to the project if issue is resolvedNo
Browsernot relevant
Database & DB-VersionMysql 5
Server OS (if known)debian/linux
Webserver software & version (if known)apache
PHP VersionPHP Version 5.3

Relationships

has duplicate 10243 closedc_schmitz Able to skip required questions when complete question index enable 
related to 09198 closedDenisChenu complete group's navigation can stop before clicked group 

Activities

DenisChenu

DenisChenu

2014-03-04 11:56

developer  

DenisChenu

DenisChenu

2014-03-04 15:42

developer   ~29090

Last edited: 2014-03-04 15:43

View 2 revisions

Tested with git reset --hard badcc4866d88023102a3f72dc4f6f2193dec16b8
And a new installation :
Same think : http://205_dev.sondages.pro/index.php/survey/index/sid/337886/newtest/Y/lang/en

Only difference : Entering someting in text are not saved when click on a 'index' group.

sammousa

sammousa

2014-09-01 09:51

reporter   ~30455

The trouble with a full question index is that some compromises need to be made:

  • If we validate questions we cannot save answers when navigating using the index. Since mandatory questions need to be filled in, validating them would deny navigation away from the page.

In my opinion the full question index should not save the current page when navigating using the index. This will provide the most consistent and easy to understand experience for the user.
Furthermore we might need some more documentation; the full question index imposes several limitations on the survey with respect to relevance equations / group relevance.

Not sure what the best way is to proceed. For 2.06 will need to rework the whole question index approach.

DenisChenu

DenisChenu

2014-09-01 09:55

developer   ~30456

Last edited: 2014-09-01 09:56

View 2 revisions

I think question index MUST save actual page. To have a button without save it's really a reverse or usuability (http://en.wikipedia.org/wiki/Usability).

In think the best is:

  • Don't validate any group/question when click on #index, but save answers
  • Validate whole survey when submitting
DenisChenu

DenisChenu

2014-10-17 08:18

developer   ~30803

Please try and do a lot of different test with https://github.com/LimeSurvey/LimeSurvey/pull/227

DenisChenu

DenisChenu

2014-11-01 18:01

developer   ~30901

Fixed here :
https://github.com/LimeSurvey/LimeSurvey/pull/227

This save value in DB but don't return error if there one.
AND the survey are rested just before submit

DenisChenu

DenisChenu

2014-11-13 16:33

developer   ~30977

Fix committed to master branch: http://bugs.limesurvey.org/plugin.php?page=Source/view&id=14619

c_schmitz

c_schmitz

2014-11-13 17:11

administrator   ~30979

Version 2.05 Build 141113 released

Related Changesets

LimeSurvey: master be983708

2014-11-01 16:47:55

DenisChenu

Details Diff
Fixed issue 09328: Language changer causes warning for mandatory questions
Fixed issue 09285: Index complet + mandatory question :undefined notice
Fixed issue 09198: complete group's navigation can stop before clicked group
Fixed issue 08806: questionindex to 2 allow invalid survey submitted
Dev: use $force in _validateGroup and _validateQuestion
Dev: this allow save value in DB for equation and some other, but never return error.
Dev: update EM, then need testing
Affected Issues
08806, 09198, 09285, 09328
mod - application/helpers/SurveyRuntimeHelper.php Diff File
mod - application/helpers/expressions/em_manager_helper.php Diff File

Issue History

Date Modified Username Field Change
2014-03-04 11:56 DenisChenu New Issue
2014-03-04 11:56 DenisChenu File Added: survey_archive_indexsubmit.lsa
2014-03-04 15:42 DenisChenu Note Added: 29090
2014-03-04 15:43 DenisChenu Note Edited: 29090 View Revisions
2014-03-04 16:37 c_schmitz Assigned To => sammousa
2014-03-04 16:37 c_schmitz Status new => feedback
2014-09-01 09:38 DenisChenu Relationship added related to 09198
2014-09-01 09:51 sammousa Note Added: 30455
2014-09-01 09:55 DenisChenu Note Added: 30456
2014-09-01 09:55 DenisChenu Status feedback => assigned
2014-09-01 09:56 DenisChenu Note Edited: 30456 View Revisions
2014-10-15 16:00 DenisChenu Assigned To sammousa => DenisChenu
2014-10-17 08:18 DenisChenu Note Added: 30803
2014-11-01 18:01 DenisChenu Note Added: 30901
2014-11-13 16:33 DenisChenu Changeset attached => LimeSurvey master be983708
2014-11-13 16:33 DenisChenu Note Added: 30977
2014-11-13 16:33 DenisChenu Resolution open => fixed
2014-11-13 16:38 DenisChenu Status assigned => resolved
2014-11-13 16:38 DenisChenu Fixed in Version => 2.05+
2014-11-13 17:11 c_schmitz Note Added: 30979
2014-11-13 17:11 c_schmitz Status resolved => closed
2016-01-25 08:21 DenisChenu Relationship added has duplicate 10243